/**
 * @file	   baseTypes.h
 * @brief      standard types
 * 
 * @author     laurent Saint-Marcel(lstmarcel@yahoo.fr)
 * @date       2002/09/02
 */
 
#ifndef __BASE_TYPES_H__
#define __BASE_TYPES_H__

#ifdef WIN32
typedef signed char   SBYTE;
typedef double        SFLOAT;
typedef unsigned char BYTE;
typedef int           BOOL;
#endif

#ifdef PIC16F87X
typedef signed char   SBYTE;
typedef float16       SFLOAT;
typedef unsigned char BYTE;
typedef BIT           BOOL;
#endif

#ifndef TRUE
/**
 * @brief   Boolean value true
 */
#define TRUE  1
#endif

#ifndef FALSE
/**
 * @brief   Boolean value False
 */
#define FALSE 0
#endif

/**
 * @brief   This function waits for 'delay x 0.1s'
 */
void sleep01(BYTE delay);

#endif /* __BASE_TYPES_H__ */
