// gameboy1.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "serial.h"

// communication header with 68hc11
#define SET_LONG_TIMER	0
#define SET_SERVO_POS_1	1
#define GET_LONG_TIMER	2
#define GET_SERVO_POS_1	3

serialCL serial;
unsigned char msg[4];
unsigned char READ;

unsigned short swapShort(unsigned short v){
	short v2 = v/256;
	v2+=256*(v%256);
	return v2;
}

int writeServoPos(int servo, unsigned short v)
{
	msg[0] = servo*2;
	msg[1] = v%256;
	msg[2] = v/256;
	if(serial.write(msg, 3) != SERIAL_SUCCESS) {
			printf("Write Error\n");
			return SERIAL_ERROR;
	}
	printf("Wrote on SET_SERVO_POS_%d : 0x%x\n", servo, v);
	return SERIAL_SUCCESS;
}

int readServoPos(int servo, unsigned short &v)
{
	msg[0] = servo*2;
	if(serial.write(msg, 1) != SERIAL_SUCCESS) {
			printf("Write Error\n");
			return SERIAL_ERROR;
	}
	unsigned long l=2;
	if(serial.forceRead(msg, l) != SERIAL_SUCCESS) {
			printf("Read Error\n");
			return SERIAL_ERROR;
	}
	v = msg[0]*256+msg[1];
	printf("Read GET_SERVO_POS_%d : 0x%4x\n", servo, v);
	return SERIAL_SUCCESS;
}

/////////////////////////////////////////

int main(int argc, char* argv[])
{
	printf("Hello World!\n");
	
	int result;
	// open serial port
	result = serial.open("COM1");
	if(result != SERIAL_SUCCESS) {
		printf("Unable to open serial port\nEnding with error\n");
		return 1;
	}
	printf("Open\n");
	unsigned short v;
	readServoPos(1, v);

	unsigned short servoPos_  = 0x1270;
	writeServoPos(1, servoPos_);

	serial.close();

	printf("Bye...\n");
	return 0;
}

