// gameboy1.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "serial.h"



#define ERROR_SERIAL 1
#define SUCCESS		 0

BYTE msg[255];

serialCL serial;

#define SERVO_MIN_POS 190
#define SERVO_MAX_POS 240

void uartSend(BYTE data)
{
	msg[0]=data;
	if(serial.write(msg, 1) != SERIAL_SUCCESS) {
		printf("Write Error\n");
	}
}

BYTE uartRecv()
{
	unsigned long l=1;
	serial.forceRead(msg, l);
	return msg[0];
}

BYTE uartRecvNobloking()
{
	unsigned long l=1;
	msg[0]=0x00;
	serial.read(msg, l);
	return msg[0];
}

#define SERVO_SET_POS_CODE	0x10
#define SERVO_SET_MASK_CODE 0x00

static BYTE servoMask[4];
static BYTE servoPos[24];

/* ------------------------------------------------------------------------*/
/* servoGetBoardInfo                                                       */
/* ------------------------------------------------------------------------*/
/* Private function that converts servoId to boardId/port/servoId          */
/* understandable by servo12.asm program                                   */
/* ------------------------------------------------------------------------*/
void servoGetBoardInfo(BYTE* servoId, 
					   BYTE* boardId, 
					   BYTE* port)
{
	*boardId=0;
	*port=0;
	if (*servoId>=12) {
		*boardId=1;
		*servoId-=12;
	}
	if (*servoId>=8) {
		*port=1;
		*servoId-=8;
	}
}

/* ------------------------------------------------------------------------*/
/* servoSetPos                                                             */
/* ------------------------------------------------------------------------*/
void servoSetPos(BYTE servoId, 
				 BYTE pos)
{
	BYTE boardId=0;
	BYTE port=0;
	servoPos[servoId]=pos;
	servoGetBoardInfo(&servoId, &boardId, &port);
	/* send header */
	BYTE v=(boardId<<5)+SERVO_SET_POS_CODE+(port<<3)+servoId;
	uartSend(v);
	printf("A: %d %d\n",v,uartRecv());
	/* send servo position */
	uartSend(pos);
	printf("A: %d %d\n",pos,uartRecv());
/*	if(uartRecv()!=pos)
		printf("Ack not received\n");*/
}

/* ------------------------------------------------------------------------*/
/* servoSetMask                                                            */
/* ------------------------------------------------------------------------*/
void servoSetMask(BYTE boardId, 
				  BYTE port, 
				  BYTE mask)
{
	/* store mask */
	servoMask[2*boardId+port]=mask;
	/* send header */
	//uartSend((boardId<<5)+SERVO_SET_MASK_CODE+(port<<3));
	BYTE v=(boardId<<5)+SERVO_SET_MASK_CODE+(port<<3);
	uartSend(v);
	printf("A: %d %d\n",v,uartRecv());
	/* send servo position */
	uartSend(mask);
	printf("A: %d %d\n",mask,uartRecv());
/*	if(uartRecv()!=mask)
		printf("Ack not received\n");*/
}

/* ------------------------------------------------------------------------*/
/* servoEnable                                                             */
/* ------------------------------------------------------------------------*/
void servoEnable(BYTE servoId, 
				 BOOL enable)
{
	BYTE boardId=0;
	BYTE port=0;
	BYTE maskId=0;
	servoGetBoardInfo(&servoId, &boardId, &port);
	maskId=2*boardId+port;
	if (enable)
		servoMask[maskId] |= 1<<servoId;
	else /* disable */
		servoMask[maskId] &= 0<<servoId;
	servoSetMask(boardId, port, servoMask[maskId]);
}

/////////////////////////////////////////
int main(int argc, char* argv[])
{
	printf("Hello World!\n");
	
	int result;
	// open serial port
	result = serial.open("COM1");
	if(result != SERIAL_SUCCESS) {
		printf("Unable to open serial port\nEnding with error\n");
		return 1;
	}
	// user main
int tt=30;	
//	servoSetMask(0,0,0xff);
int w=20;
#if 0 // middle
	servoSetPos(w+0,220); //higher =down
	servoSetPos(w+1,212); // higher =in
	servoSetPos(w+2,210); // higher=right
#endif
#if 0 // up/in/left
	servoSetPos(w+0,208); //higher =down  -12
	servoSetPos(w+1,237); // higher =in   +25
	servoSetPos(w+2,195); // higher=right -15
#endif
#if 1 // down/out/right
	servoSetPos(w+0,240); //higher =down  +20
	servoSetPos(w+1,192); // higher =in   -20
	servoSetPos(w+2,225); // higher=right +15
#endif
#if 0 // down/out/right
	servoSetPos(w+0,240); //higher =down
	servoSetPos(w+1,195); // higher =in
	servoSetPos(w+2,240); // higher=right
#endif
	servoEnable(w+0,1);
	servoEnable(w+1,1);
	servoEnable(w+2,1);
/*	Sleep(tt);
	setServoMask(0,0,0x00);
	Sleep(tt);
	setServoMask(1,0,0x00);
	*/
//	enableServo(12+7,1);
//	setServoPos(12+10,240);
//	servoEnable(12+10,0);
//	setServoMask(0,1,0xff);

/*	Sleep(tt);
	setServoPos(0,190);
	Sleep(tt);
	enableServo(0,1);
	Sleep(tt);

	setServoPos(12,190);
	Sleep(tt);
	enableServo(12+8,0);
/*	for(int w=0;w<4;w++){
	unsigned long l=4;
	if(serial.forceRead(msg, l) != SERIAL_SUCCESS) {
			printf("Read Error\n");
			return SERIAL_ERROR;
	}
	printf("Read : 0x%x 0x%x 0x%x 0x%x\n", msg[0], msg[1], msg[2], msg[3]);
	}*/
	/*
	msg[0] = (0x40)+0;
	msg[1] = 245;
	if(serial.write(msg, 2) != SERIAL_SUCCESS) {
			printf("Write Error\n");
			return SERIAL_ERROR;
	}

	unsigned long l=1;
	if(serial.forceRead(msg, l) != SERIAL_SUCCESS) {
			printf("Read Error\n");
			return SERIAL_ERROR;
	}
	printf("Read : 0x%x\n", msg[0]);
	*/
/*
	printf("1\n");
	while(1){
	msg[0] = 0x80;
	msg[1] = 245;
	if(serial.write(msg, 1) != SERIAL_SUCCESS) {
			printf("Write Error\n");
			return SERIAL_ERROR;
	}
	
	unsigned long l=1;
	if(serial.forceRead(msg, l) != SERIAL_SUCCESS) {
			printf("Read Error\n");
			return SERIAL_ERROR;
	}
	printf("Read : 0x%x\n", msg[0]);
	}
	*/
	// close serial port
	serial.close();
	printf("Bye...\n");
	return 0;
}

