// gameboy1.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "serial.h"

// communication header with 68hc11
#define SET_LONG_TIMER	0
#define SET_SERVO_POS_1	1
#define GET_LONG_TIMER	2
#define GET_SERVO_POS_1	3

serialCL serial;
unsigned char msg[4];
unsigned char READ;

unsigned short swapShort(unsigned short v){
	short v2 = v/256;
	v2+=256*(v%256);
	return v2;
}

int writeLongTimer(unsigned short v)
{
	msg[0] = SET_LONG_TIMER;
	msg[1] = v%256;
	msg[2] = v/256;
	if(serial.write(msg, 3) != SERIAL_SUCCESS) {
			printf("Write Error\n");
			return SERIAL_ERROR;
	}
	printf("Wrote on SET_LONG_TIMER  : 0x%x\n", v);
	return SERIAL_SUCCESS;
}


int writeServoPos(int servo, unsigned short v)
{
	switch(servo){
	case 1:
		msg[0] = SET_SERVO_POS_1;
		break;
	default:
		msg[0] = SET_SERVO_POS_1;
		break;
	}
	msg[1] = v%256;
	msg[2] = v/256;
	if(serial.write(msg, 3) != SERIAL_SUCCESS) {
			printf("Write Error\n");
			return SERIAL_ERROR;
	}
	printf("Wrote on SET_SERVO_POS_%d : 0x%x\n", servo, v);
	return SERIAL_SUCCESS;
}
int readLongTimer(unsigned short &v)
{
	msg[0] = GET_LONG_TIMER;
	if(serial.write(msg, 1) != SERIAL_SUCCESS) {
			printf("Write Error\n");
			return SERIAL_ERROR;
	}
	unsigned long l=2;
	if(serial.forceRead(msg, l) != SERIAL_SUCCESS) {
			printf("Read Error\n");
			return SERIAL_ERROR;
	}
	v = msg[0]*256+msg[1];
	printf("Read SET_LONG_TIMER  : 0x%x\n", v);
	return SERIAL_SUCCESS;
}


int readServoPos(int servo, unsigned short &v)
{
	switch(servo){
	case 1:
		msg[0] = GET_SERVO_POS_1;
		break;
	default:
		msg[0] = GET_SERVO_POS_1;
		break;
	}
	if(serial.write(msg, 1) != SERIAL_SUCCESS) {
			printf("Write Error\n");
			return SERIAL_ERROR;
	}
	unsigned long l=2;
	if(serial.forceRead(msg, l) != SERIAL_SUCCESS) {
			printf("Read Error\n");
			return SERIAL_ERROR;
	}
	v = msg[0]*256+msg[1];
	printf("Read GET_SERVO_POS_%d : 0x%x\n", servo, v);
	return SERIAL_SUCCESS;
}

/////////////////////////////////////////

int main(int argc, char* argv[])
{
	printf("Hello World!\n");
	
	int result;
	// open serial port
	result = serial.open("COM1");
	if(result != SERIAL_SUCCESS) {
		printf("Unable to open serial port\nEnding with error\n");
		return 1;
	}
	unsigned short v;
	readLongTimer(v);
	readServoPos(1, v);

	unsigned short longTimer_ = 0x64F7;
	unsigned short servoPos_  = 0x1270;
	writeLongTimer(longTimer_);
	writeServoPos(1, servoPos_);

	serial.close();

	printf("Bye...\n");
	return 0;
}

