#ifndef CAMERA_GAMEBOY_DRIVER
#define CAMERA_GAMEBOY_DRIVER

////////////////////////////////////////////////
// basic read write operation for 68hc11 card //
////////////////////////////////////////////////
int writeF(unsigned char v);
int readA(unsigned char &v);
int readANA(unsigned char &v);

/////////////////////////////
// SPECIFIC GAMEBOY_CAMERA //
/////////////////////////////
// Sets one of the 8 8-bit registers in the AR chip.
void setreg(unsigned char regaddr, unsigned char regval);

// requests sent by the 68hc11
// Sends a 'start' pulse to the AR chip.
int hardStartAR();
// Sends a blank 'xck' pulse to the AR chip.
int hardClockAR();
// Sends a 'reset' pulse to the AR chip.
int hardResetAR();
// send start pulse to the AR chip and read back the picture
int hardStartAndRead();

// same functions but use only basic 68hc11 read write functions
int softStartAR();
int softClockAR();
int softResetAR();
int softStartAndRead();

int startAR();
int clockAR();
int resetAR();
int startAndRead();

// Skip a picture
int skipPIC();
void restart(bool start);

// Main function
void TakeAPicture();

// unused functions
int ReadPicture();
int ReadPicture2();

#endif