/**
 * @file   spiderIO.h
 * @brief  Functions that manage robot I/Os
 *
 *
 * @author Laurent Saint-Marcel (lstmarcel@yahoo.fr)
 *
 * @date   2002/09/15
 */

#ifndef SPIDER_IO_H__
#define SPIDER_IO_H__

#include "baseTypes.h"

/**
 * @brief This function gets the foot bumper status
 * @return A byte which 6 first bits are foot status :\n
 *         1=leg on the ground\n
 *         0=leg up
 * @see ioGetFootBumper
 */
BYTE ioGetFootBumper();

/**
 * @brief set face leds
 */
void ioSetLeapLeds(BOOL modeFull);

/**
 * @brief This function gets the leg collision bumper status (!= foot)
 * @return A byte which 6 first bits are foot status :\n
 *         1=leg on the ground\n
 *         0=leg up
 * @see ioGetFootBumper
 */
BYTE ioGetLegCollisionBumper();


#endif /* SPIDER_IO_H__ */
