/**
 * @file   spiderhead.h
 * @brief  Functions that control the robot head movements...
 *
 *
 * @author Laurent Saint-Marcel (lstmarcel@yahoo.fr)
 *
 * @date   2002/09/15
 */

#ifndef SPIDER_HEAD_H__
#define SPIDER_HEAD_H__

#include "baseTypes.h"

#define HEAD_DIR_MIN   190
#define HEAD_DIR_FRONT 215
#define HEAD_DIR_MAX   240

/**
 * @brief This function moves the robot forward in the mainLegId direction
 * @param dir  direction of the head : [HEAD_DIR_MIN..HEAD_DIR_MAX],
 *             can be HEAD_DIR_FRONT
 */
void headSetPosition(BYTE dir);

/**
 * @brief The robot is happy !
 */
void headSmile();

/**
 * @brief The robot is angry !
 */
void headAngry();

/**
 * @brief The robot face has no expression
 */
void headNothing();

/**
 * @brief Disable head servo motors
 */
void headDisable();


#endif /* SPIDER_HEAD_H__ */
