// visualView.cpp : implementation of the CVisualView class
//

#include "stdafx.h"
#include "visual.h"

#include "visualDoc.h"
#include "visualView.h"

#include "../uart.h"
#include "../spidermove.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CVisualView

IMPLEMENT_DYNCREATE(CVisualView, CView)

BEGIN_MESSAGE_MAP(CVisualView, CView)
	//{{AFX_MSG_MAP(CVisualView)
	ON_COMMAND(ID_MOVE_DOWN, OnMoveDown)
	ON_COMMAND(ID_MOVE_FORWARD, OnMoveForward)
	ON_COMMAND(ID_MOVE_ROTATE_LEFT, OnMoveRotateLeft)
	ON_COMMAND(ID_MOVE_STANDBY, OnMoveStandby)
	ON_COMMAND(ID_MOVE_UP, OnMoveUp)
	ON_COMMAND(ID_MOVE_WAVE, OnMoveWave)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVisualView construction/destruction

CVisualView::CVisualView()
{
	// TODO: add construction code here
	uartInit(UART_BAUD_RATE_9600);
}

CVisualView::~CVisualView()
{
}

BOOL CVisualView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CVisualView drawing

void CVisualView::OnDraw(CDC* pDC)
{
	CVisualDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: add draw code for native data here
}

/////////////////////////////////////////////////////////////////////////////
// CVisualView printing

BOOL CVisualView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CVisualView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CVisualView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CVisualView diagnostics

#ifdef _DEBUG
void CVisualView::AssertValid() const
{
	CView::AssertValid();
}

void CVisualView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CVisualDoc* CVisualView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CVisualDoc)));
	return (CVisualDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CVisualView message handlers

void CVisualView::OnMoveDown() 
{
	// TODO: Add your command handler code here
	moveLowerPosition();
}

void CVisualView::OnMoveForward() 
{
	// TODO: Add your command handler code here
	BYTE mainLegId=0;
	BYTE dist=5;
	moveForward(mainLegId, dist); 
}

void CVisualView::OnMoveRotateLeft() 
{
	// TODO: Add your command handler code here
	BYTE angle=3;
	moveRotateLeft(angle); 
}

void CVisualView::OnMoveStandby() 
{
	// TODO: Add your command handler code here
	 moveStandingByPosition();
}

void CVisualView::OnMoveUp() 
{
	// TODO: Add your command handler code here
	moveUpperPosition();
}

void CVisualView::OnMoveWave() 
{
	// TODO: Add your command handler code here
	BYTE lapNumber=1;
	moveWave(lapNumber);
}
